<?php



if (!defined('_PS_VERSION_'))

	exit;



class robotseditor extends Module

{



	protected $_errors = array();





	public function __construct()

	{

		$this->name = 'robotseditor';

		$this->tab = 'front_office_features';

		$this->version = '1.0';

		$this->author = 'dh42';

		$this->need_instance = 0;




		$this->bootstrap = true;



	 	parent::__construct();



		$this->displayName = $this->l('Robots.txt editor');

		$this->description = $this->l('Allows you to edit the robots.txt file. From dh42 PrestaShop Certified Partner and PrestaShop support Experts.');

		$this->confirmUninstall = $this->l('Are you sure you want to delete this module?');

	}



	public function install()

	{

		if (!parent::install() OR

			!$this->registerHook('displayBackOfficeHeader')

			)

			return false;

		return true;

	}



	public function uninstall()

	{

		if (!parent::uninstall())

			return false;

		return true;

	}







	public function getContent()

	{



		if (version_compare(@_PS_VERSION_,'1.6','<'))

			$this->_html = '<h2>'.$this->displayName.'</h2>';



		$this->_postProcess();







		if (version_compare(@_PS_VERSION_,'1.6','>'))

			$this->_displayForm();

		else

			$this->_displayForm15();



		return	$this->_html;

	}



	private function _displayForm()

	{



		$this->context->controller->addJS($this->_path.'/js/ace.js', 'all');

		$robots = $this->getRobots();



		if(!$robots)

			$this->_html .= '

				<div class="module_error alert alert-danger">

					<button type="button" class="close" data-dismiss="alert">×</button>'.$this->l('Error: You don\'t have a robots file, generate one from the SEO & URLs'.$this->getRobots(). 'page').'

				</div>';

		else {



			$this->_html .= '



			  <style type="text/css" media="screen">



			    #robotsfile {

			        margin: 0;

			        position: absolute;

			        top: 0;

			        bottom: 0;

			        left: 0;

			        right: 0;

			    }

			  </style>

<div style="width:100%;height:100px;">

<div style="width:33.3%;text-align:left;float:left;height:100px">

<ins data-revive-zoneid="7" data-revive-id="27f1a68d9b3c239bbbd38cc09b79d453"></ins>

<script async src="//dh42.com/openx/www/delivery/asyncjs.php"></script>

</div>



<div style="width:33.3%;text-align:center;float:left;height:100px">

<ins data-revive-zoneid="8" data-revive-id="27f1a68d9b3c239bbbd38cc09b79d453"></ins>

<script async src="//dh42.com/openx/www/delivery/asyncjs.php"></script>

</div>



<div style="width:33.3%;text-align:center;float:right;height:100px">

<ins data-revive-zoneid="9" data-revive-id="27f1a68d9b3c239bbbd38cc09b79d453"></ins>

<script async src="//dh42.com/openx/www/delivery/asyncjs.php"></script>

</div>

</div>

				<form action="'.$_SERVER['REQUEST_URI'].'" method="post" class="defaultForm form-horizontal" enctype="multipart/form-data">



			    <div class="panel">



					<div class="panel-heading">'.$this->l('Settings').'</div>

			';



			$this->_html .='

					<div class="form-group">

						<label class="control-label col-lg-3" style="font-weight:bold;text-align:left;margin-left:15px;">'.$this->l('Robots.txt file').'</label>

						<div class="col-lg-4" style="position:relative;height: 300px;width:100%">

							<div id="robotsfile">'.$robots.'</div>

							<textarea name="robotsfile"></textarea>

						</div>

					</div>



			<script>



			var editor = ace.edit("robotsfile");

		    editor.setTheme("ace/theme/chrome");

		    editor.getSession().setMode("ace/mode/apache_conf");

		    var textarea = $(\'textarea[name="robotsfile"]\').hide();

		    textarea.text(editor.getSession().getValue());

			editor.getSession().on(\'change\', function(){

			  textarea.text(editor.getSession().getValue());

			});





			</script>

			';





			/* Submit button */

			$this->_html .='<p class="center"><input type="submit" name="submitUpdate" value="'.$this->l('Save and regenerate').'" class="btn btn-default"></p>';

		}











		$this->_html .= '

				</div>

			</form>';

	}



	private function _displayForm15()

	{



		$this->context->controller->addJS($this->_path.'/js/ace.js', 'all');

		$robots = $this->getRobots();



		if(!$robots)

			$this->_html .= '

				<div class="module_error alert alert-danger">

					'.$this->l('Error: You don\'t have a robots file, generate one from the SEO & URLs page').'

				</div>';

		else {

			$this->_html .= '



			  <style type="text/css" media="screen">



			    #robotsfile {

			        margin: 0;

			        position: absolute;

			        top: 0;

			        bottom: 0;

			        left: 0;

			        right: 0;

			    }

			  </style>





				<form action="'.$_SERVER['REQUEST_URI'].'" method="post" class="defaultForm form-horizontal" enctype="multipart/form-data">



			    	<fieldset><legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Settings').'</legend>

			';





			$this->_html .='

					<p>&nbsp;</p>

						<label >'.$this->l('Robots.txt file').'</label>

						<div class="margin-form" style="position:relative;height: 300px; width: 700px;padding-left:0;margin-left: 260px">

							<div id="robotsfile">'.$robots.'</div>

							<textarea name="robotsfile"></textarea>

						</div>





			<script>



			var editor = ace.edit("robotsfile");

		    editor.setTheme("ace/theme/chrome");

		    editor.getSession().setMode("ace/mode/apache_conf");

		    var textarea = $(\'textarea[name="robotsfile"]\').hide();
 			textarea.text(editor.getSession().getValue());
			editor.getSession().on(\'change\', function(){

			  textarea.text(editor.getSession().getValue());

			});



			</script>

			';



			/* Submit button */

			$this->_html .='<p class="center"><input type="submit" name="submitUpdate" value="'.$this->l('Save and regenerate').'" class="button"></p>';



		}







		$this->_html .= '

				</fieldset>

			</form>';



	}



	private function _postProcess()

	{







		if (Tools::isSubmit('submitUpdate')) // handles the basic config update

		{





			// check that robots is writeble

			if(!is_writable(_PS_ROOT_DIR_.'/robots.txt'))

				$this->_errors[] = $this->l('Error: Your robots file is not writable');

			else if((bool)Configuration::get('PS_USE_HTMLPURIFIER'))

				$this->_errors[] = $this->l('Error: You have to disable the HTML purifier');

			else

			{

				$fh = fopen(_PS_ROOT_DIR_.'/robots.txt', 'w+');

				fwrite($fh, Tools::getValue('robotsfile'));

				fclose($fh);

				$this->_html .= $this->displayConfirmation($this->l('Robots rewritten!'));

			}

			if ($this->_errors)

			{

				$this->_html .= $this->displayError(implode($this->_errors, '<br />'));

			}

		}

	}





	private function getRobots()

	{



		if(!file_exists(_PS_ROOT_DIR_.'/robots.txt'))

			return false;

		else if(!is_writable(_PS_ROOT_DIR_.'/robots.txt'))

			return false;

		else return file_get_contents(_PS_ROOT_DIR_.'/robots.txt');



	}



	public function hookDisplayBackOfficeHeader($params)



	{



		if( isset($this->context->controller->dh_support) )



			return;



		$this->context->controller->dh_support = 1;

		if (version_compare(@_PS_VERSION_,'1.6','<'))

			$this->context->controller->addJS($this->_path . '/dh42_15.js', 'all');

		else

			$this->context->controller->addJS($this->_path . '/dh42.js', 'all');



		return;







	}





}

